c imp_dims, imp_control, imp_gen_io has to be careful, some variables have to initialized before use. 

      subroutine h_init()
     
      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2, ilat, ilong, ivert,itloop ,
     &num_emiss, emiss_timpyr,num_qjs,num_qks,num_species,num_molefrac,
     &loc_proc, pr_diag
     
      use h_imp_control, only: imgas_num,do_clear_sky,nymd,nhms,
     &mw,emiss_map,initrogen_num,ioxygen_num, num_time_steps
      
      use h_imp_gen_io, only: pr_sulf_src,qj_var_name,
     &qj_infile_name,aqua_infile_name
      
      use h_setkin_par
      
      use h_setkin_mw, only: mw_data
      
      
      use ppgrid,     only: pver, pcols
      use spmd_utils, only: iam
      
      implicit none
      
      










      
               
c ########################  imp_dims

c static    
c      num_emiss =  3 ! three emission, fSO2, nSO2, nDMS from in_out/imp_namelist.F:1899  if (emiss_map(ic) > 0) num_emiss = num_emiss + 1
c      set this to be paramter in imp_dims , same for num_qjs, num_qks
    
      emiss_timpyr = 1 !supposed to be read in from namelist, will not be used when using CAM5 emission.      
c      num_qjs = 1
c      num_qks = 8 
      pr_diag = .FALSE.
      
      
c dynamic , depend on the decomposition
      loc_proc = iam ! from CAM

c all i and j to 1, so the first dimension degenerate.      
      i1    =  1
      i1_gl =  1
      ilo   =  1
      
      i2    =  1
      i2_gl =  1
      ihi   =  1
c      
      ju1   =  1
      julo  =  1
      ju1_gl=  1

      k1    =  1
      k2    =  pver
      
c have to assign them to ncol for each chunk,       
c      j2    =  pcols !from CAM
c      j2_gl =  pcols !from CAM
c      jhi   =  pcols !from CAM
      
c      ilat = j2 - ju1 + 1  ! number of latitudes, now set in um_aerosol_intr
      ilong  = i2 -  i1 + 1   ! number of longitudes
      ivert= k2 - k1 + 1  ! number of vertical layers
c      itloop = ilat * ilong * ivert,, now set in um_aerosol_intr
      
c dynamic, from other head file     
      num_species  = NSP !42, originall this is read in from namelist, I just set it to NSP from sekin_par.h
      num_molefrac = NMF ! from setkin_par.h
       
cc######################## end imp_dims

















c ########################  imp_control
c NEED TO update at each step !!!!!!!!!!!!!!!!!! Now prpared in subroutine um_met_fld_prep
c       nhms = 10000           ! current hour/min/sec   (HHMMSS)
c       nymd = 20101           ! current year/month/day (YYMMDD)
c       num_time_steps = 1     !number of current time steps, used to determine wheteher to call aqua phase reaction.
       

c static
      imgas_num      = IMGAS  ! from setkin_par.h, index for gas density in #/cm^3
      initrogen_num  = INITROGEN
      ioxygen_num    = IOXYGEN
      
      do_clear_sky      = .FALSE.    ! for gas and aqueous phase sulf chemistry

c      print*, 'mw_data=',mw_data(1:NSP)
      
      mw(1:NSP) = mw_data(1:NSP) ! from setkin_mw.h
     
c used for sulf emisson, will not be used when using CAM5 emission, see num_emiss above
      emiss_map(1)       = 2
      emiss_map(2)       = 3
      emiss_map(3)       = 4














c ########################  imp_gen_io
      pr_sulf_src     = .TRUE. ! should sulfur budgets    also be written to periodic
           
      qj_var_name     = 'qj'         ! NetCDF qj            variable   name
      qj_infile_name  = 'qjh2o2_2d2x5_R8.nc' 
      aqua_infile_name       = 'seasalt.75RH' ! NOT used. if used, should in Do_So2toPar_Rates
        
        
      end subroutine

