        module h_imp_time_utils
        implicit none
        public 
        save
c=============================================================================
c
c $Id: imp_time_utils.h,v 1.2 2002/03/20 21:17:26 jrt Exp $
c
c CODE DEVELOPER
c   John Tannahill, LLNL
c   jrt@llnl.gov
c
c FILE
c   imp_time_utils.h
c
c DESCRIPTION
c   This include file contains the leap_year_flag variable, which is used
c   to determine how leap years will be determined in imp_time_utils.F.
c
c=============================================================================


c     ----------
c     Constants.
c     ----------

      integer, parameter ::
     &  SIZTUSML = 16       ! small common block size


c     ----------------
c     Integer commons.
c     ----------------

      integer :: leap_year_flag = 0 !added by Cheng

      integer :: imp_tu_idum1
      integer :: imp_tu_i1_array(SIZTUSML)


cc     ====================
c      common  / imptu_i1 /
cc     ====================
c     &  imp_tu_idum1,
c     &  leap_year_flag

 
cc     ===========
c      equivalence (imp_tu_i1_array, imp_tu_idum1)
cc     ===========

      end module h_imp_time_utils
